<?php
namespace Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\DevOps\Util\Environment;

class RepositoryNew extends \Generated\Controller\RepositoryNew {

    private $environment;

    public function __construct(Manager $dataSourceManager, Environment $environment) {
        parent::__construct($dataSourceManager);
        $this->environment = $environment;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response){
        $request->getFilterCriteria()->addCondition("ORGANIZATION_ID", "=", $this->environment->getCurrentOrganizationId());
        parent::find($request, $response);
    }

}

