<?php

namespace Factory;

use Zeedhi\DevOps\Model\Configurationmanager\Entities\Product as ProductEntity;
use Zeedhi\DevOps\Model\Configurationmanager\Entities\Release as ReleaseEntity;
use Zeedhi\DevOps\Model\Configurationmanager\Entities\Subrelease as SubreleaseEntity;
use Zeedhi\DevOps\Model\Devops\Entities\ZhUserAllocation as ZhUserAllocationEntity;
use Zeedhi\DevOps\Model\Profile\Entities\ZhUser;

class ZhUserAllocation {
    /**
     * @param ZhUserAllocationEntity $userAllocation
     * @param ZhUser $zhUser
     * @param ProductEntity $product
     * @param ReleaseEntity $release
     * @param SubreleaseEntity $subrelease
     * @return ZhUserAllocationEntity
     */
    public function setZhUserAllocationRecords(ZhUserAllocationEntity $userAllocation = null,
                                               ZhUser $zhUser, ProductEntity $product = null,
                                               ReleaseEntity $release = null, SubreleaseEntity $subrelease = null)
    {
        if(!$userAllocation) {
            $userAllocation = new ZhUserAllocationEntity();
        }

        $userAllocation->setUser($zhUser);
        $userAllocation->setProduct($product);
        $userAllocation->setRelease($release);
        $userAllocation->setSubrelease($subrelease);

        return $userAllocation;
    }
} 