CREATE OR REPLACE TRIGGER STATUS_LOTECTB_NOTAFISCAL BEFORE DELETE OR UPDATE ON NOTAFISCAL
FOR EACH ROW
DECLARE
  V_CDLOTE VARCHAR2(20);
  V_NRLANCLOTE VARCHAR2(06);
  V_DTINICCTBL DATE;
  V_DTFINACCTBL DATE;
  V_IDTPGERACAOCONT VARCHAR2(01);
BEGIN
   BEGIN
      SELECT IDTPGERACAOCONT
        INTO V_IDTPGERACAOCONT
        FROM PARAMCTBL;
   EXCEPTION
    WHEN NO_DATA_FOUND THEN
      V_IDTPGERACAOCONT := NULL;
   END;

   IF V_IDTPGERACAOCONT <> 'O' THEN

      IF :OLD.IDENTRSAIDOP = 'E' THEN
         BEGIN
            SELECT DTINIINTCONTDFE, DTFININTCONTDFE
              INTO V_DTINICCTBL, V_DTFINACCTBL
              FROM CONTOPECTBL
             WHERE CDEMPRESA = :OLD.CDEMPRESA;
         EXCEPTION
           WHEN NO_DATA_FOUND THEN
            V_DTINICCTBL := NULL;
            V_DTFINACCTBL := NULL;
         END;
      ELSE
         BEGIN
            SELECT DTINIINTCONTDFS, DTFININTCONTDFS
              INTO V_DTINICCTBL, V_DTFINACCTBL
              FROM CONTOPECTBL
             WHERE CDEMPRESA = :OLD.CDEMPRESA;
         EXCEPTION
           WHEN NO_DATA_FOUND THEN
            V_DTINICCTBL := NULL;
            V_DTFINACCTBL := NULL;
         END;
      END IF;

      IF ((DELETING) OR ((UPDATING) AND (:OLD.IDSTATUS IN ('A','E') AND :NEW.IDSTATUS IN ('P','V'))))  THEN
         IF :OLD.DTENTRSAID >= V_DTINICCTBL AND :OLD.DTENTRSAID <= V_DTFINACCTBL THEN
            BEGIN
               SELECT MAX(CDLOTE) AS CDLOTE, MAX(NRLANCLOTE) AS NRLANCLOTE
                 INTO V_CDLOTE, V_NRLANCLOTE
                 FROM RELACNFLANCLOTE
                WHERE CDEMPRESA = :OLD.CDEMPRESA
                  AND CDFILIAL = :OLD.CDFILIAL
                  AND NRLANCTONF = :OLD.NRLANCTONF;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                 V_CDLOTE := NULL;
                 V_NRLANCLOTE := NULL;
            END;

            REVERTE_LOTE(:OLD.CDEMPRESA,V_CDLOTE);

            DELETE FROM RELACNFLANCLOTE
             WHERE CDEMPRESA = :OLD.CDEMPRESA
               AND CDLOTE = V_CDLOTE
               AND NRLANCLOTE = V_NRLANCLOTE
               AND CDFILIAL = :OLD.CDFILIAL
               AND NRLANCTONF = :OLD.NRLANCTONF;

            DELETE FROM LANCLOTE
             WHERE CDEMPRESA = :OLD.CDEMPRESA
               AND CDLOTE = V_CDLOTE
                AND NRLANCLOTE = V_NRLANCLOTE;

            IF UPDATING THEN
               :NEW.IDSTATUSCTBNF := 'P';
            END IF;
         ELSE
            RAISE_APPLICATION_ERROR(-20501,'Excluso no permitida, lanamento fora do perodo contbil.',True);
         END IF;
      END IF;
   END IF;
END;
/






